<?php
/* $Id: admin.php 2320 2008-10-09 12:03:42Z vadim $ */

// get settings
$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -4 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
require_once ($NETCAT_FOLDER."vars.inc.php");
require_once ($INCLUDE_FOLDER."s_common.inc.php");
require_once ($INCLUDE_FOLDER."s_loadenv.inc.php");
require_once ($ADMIN_FOLDER."function.inc.php");
//require_once ($MODULE_FOLDER."comments/function.inc.php");
require_once ($MODULE_FOLDER."comments/nc_comments_admin.class.php");

// language constants
if ( is_file($MODULE_FOLDER.'comments/'.MAIN_LANG.'.lang.php') ) {
	require_once($MODULE_FOLDER.'comments/'.MAIN_LANG.'.lang.php');
}
else { 
	require_once($MODULE_FOLDER.'comments/en.lang.php');
}

// load modules env
if ( !isset($MODULE_VARS) ) $MODULE_VARS = $nc_core->modules->get_module_vars();//LoadModuleEnv();

// UI config
require_once ($ADMIN_FOLDER."modules/ui.php");
// default
if (!$page) $page = "settings";
require_once ($MODULE_FOLDER."comments/ui_config.php");

$Title1 = NETCAT_MODULES;
$Title2 = NETCAT_MODULE_COMMENTS;



// default phase
if ( !isset($phase) ) $phase = 1;

// UI functional
$UI_CONFIG = new ui_config_module_comments('admin', $page);

// admin object
try {
  $nc_comments_admin = new nc_comments_admin();
}
catch (Exception $e) {
  BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/modules/comments/");
  // got error
  nc_print_status($e->getMessage(), "error");
  EndHtml();
  exit;
}

switch ($phase) {
  // step 1: show settings form
	case 1:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 0);
    // show settings form
    $nc_comments_admin->settings();
	break;
  
  // step 2: save settings
	case 2:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
    // save settings
    $nc_comments_admin->settingsSave();
    // successfully saved
    nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_SAVE_OK, "ok");
    // show settings form
    $nc_comments_admin->settings();
	break;
  
  // step 3, 4, 5: converter
  case 3:
  case 4:
  case 5:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
    // catalogue if setted
    $conv_catalogue = $_POST['ConverterCatalogue'] ? $_POST['ConverterCatalogue'] : 0;
    // subdivision if setted
    $conv_subdivision = $_POST['ConverterSubdivision'] ? $_POST['ConverterSubdivision'] : 0;
    // show convert form
    $nc_comments_admin->converter($phase, $conv_catalogue, $conv_subdivision);
  break;
  
  // step 6: converter done
  case 6:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
    // save convert
    if ( $nc_comments_admin->converterSave() ) {
      // successfully converted
      nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_CONVERT_OK, "ok");
    }
    // show convert form
    $nc_comments_admin->converter();
  break;
  
  case 7:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
    // show optimize form
    $nc_comments_admin->optimize();
  break;
  
  case 8:
    BeginHtml ($Title2, $Title1, "http://".$DOC_DOMAIN."/settings/modules/comments/");
    // check permission
    $perm->ExitIfNotAccess(NC_PERM_MODULE, 0, 0, 0, 1);
    // save optimize data
    if ( $_POST['OptimizeComments']) {
      if ( $_commentsOptimized = $nc_comments_admin->optimizeSave() ) {
        // successfully optimized
        nc_print_status( str_replace("%COUNT", $_commentsOptimized, NETCAT_MODULE_COMMENTS_ADMIN_OPTIMIZE_OK), "ok" );
      }
      else {
        // no data
        nc_print_status(NETCAT_MODULE_COMMENTS_ADMIN_OPTIMIZE_NO_DATA, "info");
      }
    }
    // show optimize form
    $nc_comments_admin->optimize();
  break;
}

EndHtml();
?>