<?php
/* $Id: function.inc.php 3321 2009-06-04 13:10:51Z vadim $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");

require_once ($ROOT_FOLDER.'connect_io.php');
require_once ($ADMIN_FOLDER.'CheckUserFunctions.inc.php');
require_once ($ADMIN_FOLDER.'catalog.inc.php');
require_once ($ADMIN_FOLDER.'class.inc.php');
require_once ($ADMIN_FOLDER.'message.inc.php');
require_once ($ADMIN_FOLDER.'template.inc.php');
require_once ($ADMIN_FOLDER.'field.inc.php');
require_once ($ADMIN_FOLDER.'system_table.inc.php');
require_once ($ADMIN_FOLDER.'module.inc.php');
require_once ($ADMIN_FOLDER.'admin.inc.php');

// Admin Interface Initialization
$admin_mode = true;
if ($AUTHORIZATION_TYPE=='session') { session_start(); }

LoadSettings();
Authorize(1);

#   
if ($_POST["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_POST["NEW_AUTH_LANG"];
}
elseif($_GET["NEW_AUTH_LANG"])
{
    $SETNEWLANG=$_GET["NEW_AUTH_LANG"];
}

#   
if ($AUTH_USER_ID && $NEW_AUTH_LANG) {
  $AUTH_LANG=$SETNEWLANG;
  //         
  //  Authorize --   if ($Language)

  // setcookie('AUTH_LANG', $AUTH_LANG, mktime(0,0,0,1,1,2037), "/");
  $db->query("UPDATE `User` SET `Language` = '".$db->escape($AUTH_LANG)."' WHERE `User_ID` = '".$AUTH_USER_ID."'");
}

if ( $nc_personal ) $AUTH_LANG = $PHP_AUTH_LANG = $ADMIN_LANGUAGE = "Russian";  

if (preg_match("/^\w+$/", $AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $PHP_AUTH_LANG))
{
    require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
}
elseif(preg_match("/^\w+$/", $_SESSION['User']['PHP_AUTH_LANG']))
{
    require_once($ADMIN_FOLDER."lang/".$_SESSION['User']['PHP_AUTH_LANG'].".php");
}
else
{
    if (!$PHP_AUTH_LANG) {
      $PHP_AUTH_LANG = NetCat_language_detect();
    }
    if ($PHP_AUTH_LANG) {
      require_once($ADMIN_FOLDER."lang/".$PHP_AUTH_LANG.".php");
    }
    else {
      require_once($ADMIN_FOLDER."lang/".$ADMIN_LANGUAGE.".php");
    }
}

//    ,    
// ""  
header("Content-Type: text/html; charset=".MAIN_ENCODING);


//        

if (!$perm->isInsideAdmin() ) {
   BeginHtml (BEGINHTML_TITLE, BEGINHTML_TITLE, "http://".$DOC_DOMAIN."/admin/");
   nc_print_status($NO_RIGHTS_MESSAGE, 'error');
   EndHtml ();
   exit;
}

//    
$treeMode  ='users';
if ($perm->isAccessDevelopment() ) {
  $treeMode ='developer';  
}
if ( $perm->isAccessSiteMap()  ) {
  $treeMode ='sitemap';
}

$load_all_modules = strstr($REQUEST_URI, $HTTP_ROOT_PATH."modules") ? true : false;

$inside_admin = true;
$nc_core->modules->load_env( $nc_core->lang->acronym_from_full($AUTH_LANG), !$load_all_modules);
// --- Common functions

function LoadSettings () {
  global $nc_core, $db;
  global $IsInsideAdmin, $system_env;
  global $PROJECT_NAME, $VERSION_ID, $PLUGS_INSTALL_TYPE, $ANY_SYSTEM_MESSAGE, $SYSTEM_ID,$ADMIN_FOLDER;
  global $SPAM_FIELD, $SPAM_MAIL, $SPAM_FROM, $SPAM_FROM_NAME, $NO_RIGHTS_MESSAGE, $PATCH_CHECK_DATE;
  global $LAST_PATCH, $LAST_LOCAL_PATCH, $SYSTEM_NAME, $SYSTEM_COLOR;
  global $HTTP_HOST, $REMOTE_ADDR, $HTTP_USER_AGENT, $HTTP_ROOT_PATH;
  global $EDITOR_TYPE, $EMBED_EDITOR, $SUB_FOLDER;
  global $REMIND_SAVE;
  global $nc_personal;

  $Array = $nc_core->get_settings();

  // probably system was not installed:
  if ( !sizeof($Array) ) {
    if ( file_exists($nc_core->DOCUMENT_ROOT.$nc_core->SUB_FOLDER."install/index.php") ) {
      header("Location: ".$nc_core->SUB_FOLDER."/install/");
    }
    else {
      print "<p><b>".NETCAT_ERROR_DB_CONNECT."</b></p>";
    }
    die();
  }

  $PROJECT_NAME = $Array['ProjectName'];
  $PRODUCT_CODE = $Array['ProductNumber'];
  $SYSTEM_ID = $Array['SystemID'];
  $VERSION_ID = $Array['VersionNumber'];
  $SPAM_FIELD = $Array['UserEmailField'];
  $SPAM_MAIL = $Array['UserEmail'];
  $SPAM_FROM = $Array['SpamFromEmail'];
  $SPAM_FROM_NAME = $Array['SpamFromName'];
  $EDITOR_TYPE = $Array['EditorType'];
  $EMBED_EDITOR = $Array['EmbedEditor'];
  $REMIND_SAVE = $Array['RemindSave'];

  list($SYSTEM_NAME, $SYSTEM_COLOR) = nc_system_name_by_id($SYSTEM_ID);

  if ($SYSTEM_ID == 10) $nc_personal = true;
  
  $PLUGS_INSTALL_TYPE = "int";

  $LAST_LOCAL_PATCH = $db->get_var("SELECT `Patch_Name` FROM `Patch` ORDER BY `Patch_Name` DESC LIMIT 1");
  $LAST_LOCAL_PATCH += 0;

  list($LAST_PATCH,$PATCH_CHECK_DATE,$PATCH_CHECK_NEEDED) = $db->get_row("SELECT `LastPatch`, DATE_FORMAT(PatchCheck, '%d.%m.%Y'), DATE_ADD(PatchCheck, INTERVAL 7 DAY)<=CURDATE() FROM `Settings`", ARRAY_N);

  if (($PATCH_CHECK_NEEDED!="0" && (int)sprintf("%0-3s", $LAST_LOCAL_PATCH)>=(int)sprintf("%0-3s", $LAST_PATCH) ) || $IsInsideAdmin) {
    // get module list in order to get correct patch
    require($ADMIN_FOLDER."modules/module_list.inc.php");

    $installed_modules = $db->get_results("SELECT `Keyword`
      FROM `Module`
      WHERE `Keyword` IN ('".join("','", array_keys($real_modules))."')", ARRAY_N);
    // flatten array:
    if ($installed_modules) {
      foreach ($installed_modules as $k=>$v) { $installed_modules[$k] = $v[0]; }
      $installed_modules = urlencode(join(',', $installed_modules));
    }

    $LAST_PATCH = "";

    // link to netcat.ru patch informer
    $patch_url = "/netcat/modules/default/patch.php?system=".$Array['SystemID']."&version=".$Array['VersionNumber']."&lastpatch=".$LAST_LOCAL_PATCH."&host=".$HTTP_HOST."&product=".$PRODUCT_CODE."&useremail=".urlencode($SPAM_FROM)."&adminfolder=".urlencode($ADMIN_FOLDER)."&userip=".$REMOTE_ADDR."&useragent=".urlencode($HTTP_USER_AGENT)."&modules=".$installed_modules;

    if (strpos(ini_get("disable_functions"), "fsockopen")===FALSE) {
      $fs = @fsockopen("www.netcat.ru", 80, $errno, $errstr, 7);
      if ($fs) {
        $req  = "GET ".$patch_url." HTTP/1.0\r\n";
        $req .= "Host: www.netcat.ru\r\n";
        $req .= "Connection: Close\r\n\r\n";

        fwrite($fs, $req);
        while (!feof($fs)) {
          $response .= fgets($fs, 1024);
        }
        fclose($fs);

        $LAST_PATCH = preg_replace("/^.+?\r\n\r\n/s", "", $response);
      }
    }
    else {
      $LAST_PATCH = @join('', @file("http://www.netcat.ru".$patch_url));
    }
    // update last patch
    $db->query("UPDATE `Settings` SET `PatchCheck` = CURDATE(), `LastPatch` = '".intval($LAST_PATCH)."'");
    // update internal data
    $nc_core->get_settings("", true);
  }

  $ANY_SYSTEM_MESSAGE = $db->get_var("SELECT COUNT(*) FROM `SystemMessage` WHERE `Checked` = 0");

  $system_env['Powered'] = "PHP/".phpversion();
}


/**
 * Get favorites subdivision
 *@param  Return type: object, array_a, array_n
 *
 * @return 2xarray. Keys: id, name, catalogueID, urls, checked. domain, catalogueName 
 */
function GetFavorites ( $returnType = 'ARRAY_A') {
  global $db, $perm;
  $select = "sub.Subdivision_ID, sub.Subdivision_Name, sub.Catalogue_ID, sub.ExternalURL, sub.Hidden_URL, sub.Checked AS SubChecked,
             catalogue.Domain, catalogue.Catalogue_Name, catalogue.Checked AS CatalogueChecked";
  
  //    , \.  - 
  $allow_id = $perm->GetAllowSub($CatalogueID, MASK_ADMIN | MASK_MODERATE, false, true, false);
  $security_limit = is_array($allow_id) ? "Subdivision_ID IN(".join(',', (array)$allow_id).")" : "1";
  
  $favorites = $db->get_results("SELECT ".$select."
                                   FROM Subdivision AS sub
                              LEFT JOIN Catalogue AS catalogue ON catalogue.Catalogue_ID = sub.Catalogue_ID
                                  WHERE sub.Favorite = '1' AND ".$security_limit."
                               ORDER BY Catalogue_ID,
                                        Subdivision_ID", $returnType);
  

  return $favorites;
}



#     , $dir_name -  , , /netcat/tmp/
function checkPermissions($dir_name,$DOCUMENT_ROOT="") {
global $SUB_FOLDER;

	$dir_name = $SUB_FOLDER.$dir_name;

	if(substr(php_uname(),0,7)=="Windows")
		$filepath=$DOCUMENT_ROOT.$dir_name."n123.tmp";
	else
		$filepath=dirname(__FILE__)."/../..".$dir_name."n123.tmp";

	$h = @fopen($filepath, "w");
	if ($h === FALSE)
	{
		nc_print_status(NETCAT_FILEUPLOAD_ERROR, 'error', $dir_name);
		$result = FALSE;
	}
	else
	{
		fclose($h);
		@unlink($filepath);
		$result = TRUE;
	}

	return $result;
}

/**
  *  (<option>)    (<select>)
  *
  * @param array  ,    
  *     (   value, description;  -
  *    parent;   parent,     
  *    ; optgroup;   optgroup  ,   )
  * @param mixed  
  * @param ingeger     (   )
  *
  * @return string
  */
function nc_select_options(&$data, $selected_value="", $level=0, $current_parent=0) {

  if (!is_array($data)) {
    trigger_error("nc_select_options: first parameter is not an array", E_USER_WARNING);
    return "";
  }

  $str = "";
  if (!$level) //   
  {
     if (array_key_exists('parent', $data[0])) { //   parent
       foreach ((array)$data as $row) {
         $values[$row['parent']][] = $row;
       }
     }
     else { //           
       $values = array(&$data);
     }
  }
  else { //   
    $values = &$data;
  }

  foreach ((array)$values[$current_parent] as $row) {
     if ($row['optgroup'] && ($optgroup != $row['optgroup'])) {
       $optgroup = $row['optgroup'];
       $str .= "<optgroup label='".$optgroup."'>\n";
     }
     $str .= "<option ".($row['without_cc'] ? 'style=\'color: #cccccc;\'' : '')." value=\"".htmlspecialchars($row['value'])."\"".
             ($row['value']==$selected_value ? ' selected' : '').
             ">".
             str_repeat("&nbsp; &nbsp; &nbsp;", $level) .
             htmlspecialchars($row['description'])."</option>\n";

     if ($values[$row['value']]) {
       $str .= nc_select_options($values, $selected_value, $level+1, $row['value']);
     }
  }

  return $str;
}


/**
  *     
  *
  * @param string $value  
  * @param array $array ,     $value
  * @return bool
  */
function nc_deep_in_array($value, $array) {
    foreach($array as $item) {
        if(!is_array($item)) {
            if ($item == $value) return true;
            else continue;
        }

        if(in_array($value, $item)) return true;
        else if(nc_deep_in_array($value, $item)) return true;
    }
    return false;
}


/**
  *   " "     ExternalURL
  *( ,  ,  )
  *
  * @param array $data       Subdivision
  * @param bool $sid_off   id 
  * @return string
  */
function nc_subdivision_preview_link ($data, $sid_off = false) {
  global $DOMAIN_NAME, $SUB_FOLDER;
  
  if ( !is_array($data) ) {
    if ( is_object($data) ) {
      $data = (array)$data;
    }
    else return false;
  }
  if ( !array_key_exists("Hidden_URL", $data) ) return false;
  
  if ($data['ExternalURL']) {
    $result = strchr($data['ExternalURL'], ":")
      ? $data['ExternalURL']
      : "http://".($data['Domain']
        ? ( strchr($data['Domain'], ".") ? $data['Domain'] : $data['Domain'].".".$DOMAIN_NAME)
        : $DOMAIN_NAME
      ).$SUB_FOLDER.($data['ExternalURL']
        ? (!preg_match("/^\/.*$/", $data['ExternalURL'])
          ? $data['Hidden_URL'].$data['ExternalURL']
          : $data['ExternalURL']
        )
        : $data['Hidden_URL']
      );
  }
  else {
    $result = "http://".($data['Domain']
      ? (strchr($data['Domain'], ".")
        ? $data['Domain']
        : $data['Domain'].".".$DOMAIN_NAME
      )
      : $DOMAIN_NAME).$data['Hidden_URL'];
  }
  
  if (!$sid_off) {
    $sid_suffix = (session_id() ? "?".session_name()."=".session_id() : "");
    if ( isset($_GET[session_name()]) ) $result.= $sid_suffix;
  }
  
  return $result;
}

function nc_system_name_by_id ($id) {
  switch ($id) {
    case 1:
      $system_name = "Small Business";
      $system_color = "#FF9900";
    break;
    case 2:
      $system_name = "Standard";
      $system_color = "#2690CF";
    break;
    case 3:
      $system_name = "Extra";
      $system_color = "#CC3300";
    break;
    case 4:
      $system_name = "Community";
      $system_color = "#65C11A";
    break;
    case 5:
      $system_name = "Lite";
      $system_color = "#000000";
    break;
    case 6:
      $system_name = "E-Commerce";
      $system_color = "#F07D22";
    break;
    case 7:
      $system_name = "SEO";
      $system_color = "#FDCC6D";
    break;
    case 8:
      $system_name = "Corporate";
      $system_color = "#525F67";
    break;
    case 10:
      $system_name = "Personal";
      $system_color = "#990066";
  }
  
  return array($system_name, $system_color);
}

if ( !function_exists("nc_module_check_by_keyword") ) {
  /**
   * Check installed module by keyword
   *
   * @param string module keyword
   * @param bool `Installed` column
   * @return int `Module_ID` or false
   */
  function nc_module_check_by_keyword ($keyword, $installed = true) {
    global $nc_core;
    $module_data = $nc_core->modules->get_by_keyword($keyword, $installed);
    if ( $module_data )
      return $module_data['Module_ID'];
      
    return false;
  }
}

?>