<?php

/**
*    
* 
* <p>       :
* <b>imgResize</b> -    </p>
*      <b>nc_System</b>
*
* @see nc_ImageTransform::imgResize()
*/
class nc_ImageTransform extends nc_System {

  protected static $_db;

/**
 *
 *    
 * @access public
 * @static 
 * @param string $src_img     
 * @param string $dest_img    
 * @param int    $width      
 * @param int    $height     
 * @param int    $mode     [optional]  : 0 -  ; 1 -    ,  
 * @param string $format   [optional]    (jpg, gif, png)
 * @param int    $quality  [optional]    (0-100)  $format=='jpg'
 * @return mixed     false      
 */
  public static function imgResize($src_img, $dest_img, $width, $height, $mode=0, $format='jpg', $quality=90) {
  
    if (!file_exists($src_img)) return false;
    $img_size = getimagesize($src_img);
    if ($img_size === false) return false;

    $img_format = strtolower(substr($img_size['mime'], strpos($img_size['mime'], '/') + 1));
    if (!function_exists($fn_imgcreatefrom = 'imagecreatefrom'.$img_format)) return false;

    $x_ratio = $width  / $img_size[0];
    $y_ratio = $height / $img_size[1];

    $fn_extrem = $mode ? 'max' : 'min';
    $ratio = $fn_extrem($x_ratio, $y_ratio);

    $new_width  = $x_ratio == $ratio ? $width  : floor($img_size[0] * $ratio);
    $new_height = $x_ratio != $ratio ? $height : floor($img_size[1] * $ratio);
    $new_left = $x_ratio == $ratio || !$mode ? 0 : floor(($width - $new_width) / 2);
    $new_top  = $x_ratio != $ratio || !$mode ? 0 : floor(($height - $new_height) / 2);

    $gd_dest_img = imagecreatetruecolor($mode?$width:$new_width, $mode?$height:$new_height);
    $gd_src_img = $fn_imgcreatefrom($src_img);

    imagecopyresampled($gd_dest_img, $gd_src_img, $new_left, $new_top, 0, 0, $new_width, $new_height, $img_size[0], $img_size[1]);
    switch ($format) {
      case 'gif': imagegif ($gd_dest_img, $dest_img); break;
      case 'png': imagepng ($gd_dest_img, $dest_img); break;
      default:    imagejpeg($gd_dest_img, $dest_img, $quality); break;
    }
    imagedestroy($gd_dest_img);
    imagedestroy($gd_src_img);

    return $dest_img;
  }
  
  /**
   *    thumbnails    ,
   *    ,  .
   *
   * @global array  $GLOBALS
   * @global string $FILES_FOLDER
   * @param string  $src_field_name -  -
   * @param string  $dest_field_name -  -
   * @param int     $width         
   * @param int     $height        
   * @param int     $mode     [optional]  : 0 -  ; 1 -    ,  
   * @param string  $format   [optional]    (jpg, gif, png)
   * @param int     $quality  [optional]    (0-100)  $format=='jpg'
   *
   * @return bool true   , false -   .
   * @access public
   * @static
   */

  public static function createThumb($src_field_name, $dest_field_name, $width, $height, $mode=0, $format='jpg', $quality=90) {

    global $GLOBALS;
    global $message, $classID;

    $src_field_id  = $GLOBALS['fldID'][array_search($src_field_name,  $GLOBALS['fld'])];
    $dest_field_id = $GLOBALS['fldID'][array_search($dest_field_name, $GLOBALS['fld'])];

    return self::createThumb_byID($classID, $message, $src_field_id, $dest_field_id, $width, $height,$mode,$format,$quality, $src_field_name);
  }
  /**
   *     thumbnails    
   *
   *
   * @global  object $nc_core
   * @param   int   $classID -   ()
   * @param   int   $message -  
   * @param   int   $field_src_id -   
   * @param   int   $field_dst_id -   
   * @param   int   $width      
   * @param   int   $height     
   * @param   int   $mode     [optional]  : 0 -  ; 1 -    ,  
   * @param   string $format  [optional]    (jpg, gif, png)
   * @param   int   $quality  [optional]    (0-100)  $format=='jpg'
   * @param   string $field_name_src
   * @return  bool true   , false -   .
   * @access  public
   * @static
   */
  public static function createThumb_byID($classID,$message,$field_src_id, $field_dst_id, $width, $height, $mode=0, $format='jpg', $quality=90,$field_name_src='') {
    global $nc_core;
    
    //  
    $message += 0;
    $field_src_id += 0;
    $field_dst_id += 0;
    $classID += 0;
    if ( !$message || !$field_src_id || !$field_dst_id || !$classID ) return false;
    
    #   
    //   
    if ( !$field_name_src ) { $field_name_src = $nc_core->db->get_var("SELECT `Field_Name` FROM `Field` WHERE `Field_ID` = '".$field_src_id."'"); }
    if ( !$field_name_src ) return 0;

    //     
    $message_field = $nc_core->db->get_row("SELECT * FROM `Message".$classID."` WHERE  `Message_ID` = '".$message."'", ARRAY_A);
    $file_data = explode(':',  $message_field[$field_name_src]);
    $file_name = $file_data[0];
    $file_type = $file_data[1];
    $file_size = $file_data[2];
    $ext = substr($file_name, strrpos($file_name, ".")); //  
    $file_name = substr($file_name, 0, strrpos($file_name, ".")); //    .
    //     Filetable ?
    $filetable = $nc_core->db->get_row("SELECT * FROM `Filetable`
                                            WHERE `Message_ID` = '".intval($message)."' AND `Field_ID` = '".intval($field_src_id)."'", ARRAY_A);
    //     
    if ( $filetable ) { //    protected
      $path_src = rtrim($nc_core->FILES_FOLDER, '/').$filetable['File_Path'].$filetable['Virt_Name'];
    }
    else {
      if ( $file_data[3] ) { // orignal
        $path_src = $nc_core->FILES_FOLDER.$file_data[3];
      }
      else { // simple
        $path_src = $nc_core->FILES_FOLDER.$field_src."_".$message.$ext;
      }
    }

    //    -
    $field_info_desc = $nc_core->db->get_row("SELECT `Field_Name`, `Format` FROM `Field` WHERE `Field_ID` = '".$field_dst_id."'", ARRAY_A);
    if ( !$field_info_desc) return false;

    //  
    require_once($nc_core->INCLUDE_FOLDER."s_files.inc.php");
    DeleteFile($field_dst_id, $field_info_desc['Field_Name'], $classID, 0, $message);

    //    
    $fs = nc_field_parse_format($field_info_desc['Format'], NC_FIELDTYPE_FILE);
    $fs = $fs['fs'];

    $file_name.="_thumb";
    //       

    switch ( $fs ) {
      case NC_FS_PROTECTED:
        $path_dsc = $message_field['Subdivision_ID'].'/'.$message_field['Sub_Class_ID'].'/';
        $name_dsc =  md5($file_name.date("H:i:s d.m.Y").uniqid("netcat"));
        break;
      case NC_FS_ORIGINAL:
        $path_dsc = $message_field['Subdivision_ID'].'/'.$message_field['Sub_Class_ID'].'/';
        $name_dsc = nc_get_filename_for_original_fs($file_name.".".$format, $nc_core->FILES_FOLDER.$path_dsc);
        break;
      case NC_FS_SIMPLE:
        $path_dsc = '';
        $name_dsc = $field_dst."_".$message.$ext;
        break;
    }

    //  
    //copy($path_src, $nc_core->FILES_FOLDER.$path_dsc.$name_dsc);
    //  thumb
    $path_dest = $nc_core->FILES_FOLDER.$path_dsc.$name_dsc;
    self::imgResize($path_src, $path_dest, $width, $height, $mode, $format, $quality);

    switch ( $fs ) {
      case NC_FS_PROTECTED :
        $img_size = getimagesize($path_dest);
        if ($img_size === false) {
          if ( file_exists($path_dest) ) unlink($path_dest);
          return false;
        }
        $dst_File_Type = $img_size['mime'];
        $dst_File_Size = filesize($path_dest);
        $insert_filetable_sql = "INSERT INTO `Filetable`(Real_Name, Virt_Name, File_Path, File_Type, File_Size, Message_ID, Field_ID)
                               VALUES('".$file_name.".".$format."', '".$name_dsc."', '/".$path_dsc."','".$dst_File_Type."', '".$dst_File_Size."', '".$message."', '".$field_dst_id."')";
        
        $nc_core->db->query($insert_filetable_sql);
        $in_db = $file_name.":".$dst_File_type.":".$dst_File_size; // ,    
        break;
      case NC_FS_ORIGINAL :
        $in_db = $file_name.".".$format.":".$format.":".$file_size; // ,    
        $in_db .= ":".$path_dsc.$name_dsc;
        break;
      default :
        $in_db = $file_name.".".$format.":".$format.":".$file_size; // ,    
        break;
    }
    //    
    $nc_core->db->query("UPDATE `Message".$classID."` SET `".$field_info_desc['Field_Name']."` = '".$in_db."' WHERE `Message_ID` = '".$message."'");

    return true;
  }
}
?>
