<?php
/* $Id: index.php 3336 2009-06-08 11:11:31Z vadim $ */

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -3 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require_once ($ROOT_FOLDER.'connect_io.php');

// load default extensions
$nc_core->load_default_extensions();

$catalogue += 0;
$sub += 0;
$cc += 0;
$classID += 0;
$template += 0;
$is_there_any_files = 0;

if ( is_array($message) && !empty($message) ) {
  foreach ( $message as $k => $v) {
    $message[$k]+= 0;
  }
}
else {
  $message+= 0;
}

require_once ($nc_core->INCLUDE_FOLDER.'s_loadenv.inc.php');
require_once ($nc_core->INCLUDE_FOLDER.'s_e404.inc.php');
require_once ($nc_core->INCLUDE_FOLDER.'s_auth.inc.php');
require_once ($nc_core->INCLUDE_FOLDER.'s_browse.inc.php');
require_once ($nc_core->INCLUDE_FOLDER.'s_list.inc.php');
require_once ($nc_core->INCLUDE_FOLDER.'s_class.inc.php');
require_once ($nc_core->ADMIN_FOLDER.'CheckUserFunctions.inc.php');

if ($nc_core->PHP_AUTH_LANG==false && $nc_core->AUTHORIZATION_TYPE=='session') session_start();

// parse url
$nc_core->url->parse_url();

if ( strstr( $nc_core->url->get_parsed_url('path'), $nc_core->SUB_FOLDER.$nc_core->HTTP_ROOT_PATH."modules/") ) {
  $posting = true;
}

//  netcat-admin:  
$nc_core->inside_admin = ( !$passed_thru_404 && $nc_core->input->fetch_get_post('inside_admin') );
// old value
$inside_admin = $nc_core->inside_admin;

if ($nc_core->inside_admin) {
  //   netcat-admin ( )   $cc
  if ( $cc && !($sub || $catalogue) ) {
    $cc_data = $nc_core->sub_class->get_by_id($cc);
    $catalogue = $cc_data["Catalogue_ID"];
    $sub = $cc_data["Subdivision_ID"];
  }
  //      classID, message
  if (!$cc && $classID && $message) {
    list($catalogue, $sub, $cc) = $db->get_row("SELECT s.`Catalogue_ID`, m.`Subdivision_ID`, m.`Sub_Class_ID`
      FROM `Message".intval($classID)."` as m, `Subdivision` as s
      WHERE m.`Message_ID` = '".intval($message)."'
      AND m.`Subdivision_ID` = s.`Subdivision_ID`", ARRAY_N);
    
  }
}

// set current data
$current_catalogue = $nc_core->catalogue->set_current_by_id($catalogue);
$current_sub = $nc_core->subdivision->set_current_by_id($sub);
$current_cc = $nc_core->sub_class->set_current_by_id($cc);
// get additional data for compatibility
$parent_sub_tree = $nc_core->subdivision->get_parent_tree($sub);
$sub_level_count = $nc_core->subdivision->get_level_count($sub);

// set admin mode
switch (true) {
  case !$passed_thru_404 && !$posting:
    $nc_core->admin_mode = true;
    // old value
    $admin_mode = $nc_core->admin_mode;
  break;
  case !$passed_thru_404 && $posting:
    $nc_core->admin_mode = $admin_mode;
  break;
  case $passed_thru_404:
    $nc_core->admin_mode = false;
    // old value
    $admin_mode = $nc_core->admin_mode;
  break;
  default:
    $nc_core->admin_mode = false;
}

if (!$current_catalogue) {
  // not admin mode
  if (!$catalogue) {
    // get current catalogue temporary data and set as current
    $nc_core->catalogue->get_by_host_name($nc_core->HTTP_HOST, true);
    // set current catalogue
    $current_catalogue = $nc_core->catalogue->get_current();
    // catalogue id
    $catalogue = $nc_core->catalogue->get_current("Catalogue_ID");
  }
  else {
    // get by id
    $current_catalogue = $nc_core->catalogue->set_current_by_id($catalogue);
  }
}

$admin_url_prefix = $nc_core->SUB_FOLDER.$nc_core->HTTP_ROOT_PATH;

// load modules files and parse params data
$MODULE_VARS = $nc_core->modules->load_env();

//LoadEnv();
$nc_core->load_env();

// get system settings for compatibillity
$system_env = $nc_core->get_settings();

$operation_array = "";
// simple cc variables
if ($cc) {
  $operation_array = "current_cc";
  $moderationID = $current_cc["Moderation_ID"];
  $classID = $current_cc["Class_ID"];
  $DeleteTemplate = $current_cc["DeleteTemplate"];
  $DeleteCond = $current_cc["DeleteCond"];
}
// user mode variables
if ($user_table_mode) {
  $operation_array = "user_table_env";
  $systemTableID = $user_table_env["System_Table_ID"];
}
// general user & cc variables
if ($cc || $user_table_mode) {
  $allowTags = ${$operation_array}["AllowTags"];
  $daysToHold = ${$operation_array}["DaysToHold"];
  $titleTemplate = ${$operation_array}["TitleTemplate"];
  $addTemplate = ${$operation_array}["AddTemplate"];
  $addCond = ${$operation_array}["AddCond"];
  $addActionTemplate = ${$operation_array}["AddActionTemplate"];
  $editTemplate = ${$operation_array}["EditTemplate"];
  $editCond = ${$operation_array}["EditCond"];
  $editActionTemplate = ${$operation_array}["EditActionTemplate"];
  $CheckActionTemplate = ${$operation_array}["CheckActionTemplate"];
  $DeleteActionTemplate = ${$operation_array}["DeleteActionTemplate"];
  $searchTemplate = ${$operation_array}["SearchTemplate"];
  $subscribeCond = ${$operation_array}["SubscribeCond"];
  $subscribeTemplate = ${$operation_array}["SubscribeTemplate"];
}
unset ($operation_array);

$check_auth = s_auth($current_cc, $action, $posting);

$AUTH_USER_ID += 0;
$AUTH_USER_GROUP += 0;

if ( $nc_core->modules->get_by_keyword('auth') ) {
  AttemptToAuthorize();
}
elseif ($PHP_AUTH_USER) {
  Authorize();
}

if ($AUTH_USER_ID) {
  
  if ( $nc_core->get_settings('FirePHP') && is_object($perm) && $perm->isSupervisor() ) {
    require_once ($nc_core->INCLUDE_FOLDER."lib/FirePHPCore/index.php");
  }
  /*
  if ( !$nc_core->user->get_current() ) {
    // if module auth not installed, only language variable may helpfull
    $current_user = $nc_core->user->set_current_by_id($AUTH_USER_ID);
  }
  */
  if (!$current_user) {
    $current_user = $db->get_row("SELECT `Language` FROM `User` WHERE `User_ID` = '".$AUTH_USER_ID."'", ARRAY_A);
  }

  $PHP_AUTH_LANG = $current_user['Language'];
  $AUTH_LANG = $current_user['Language'];

  $cookie_domain = ($nc_core->modules->get_vars('auth', 'COOKIES_WITH_SUBDOMAIN') ? str_replace("www.", "", $nc_core->HTTP_HOST) : NULL);
  setcookie ("PHP_AUTH_LANG", $PHP_AUTH_LANG, ($nc_core->ADMIN_AUTHTIME ? time() + $nc_core->ADMIN_AUTHTIME : time() + 24 * 3600), "/", $cookie_domain);
}

if( $nc_core->modules->get_vars('netshop') ) {
  // session for NetShop
  $netshop_sid = session_name();
  if ($GLOBALS[$netshop_sid]) session_id($GLOBALS[$netshop_sid]);
  // if session was started already  - generates a notice
  @session_start();
  // init shop object
  if ( $nc_core->modules->get_vars('netshop') ) $GLOBALS['shop'] = new NetShop();
} 

// determine site language
if ( $nc_core->catalogue->get_current('Language') ) {
	$SITE_LANG = NetCat_language_detect( $nc_core->catalogue->get_current('Language') );
}

// language name
switch (true) {
  case $SITE_LANG:
    if($admin_mode==true) {
      $LANG_NAME = $ADMIN_LANGUAGE;
    }
  	else {
      $LANG_NAME = $SITE_LANG;
    }
  break;
  case $AUTH_LANG:
    $LANG_NAME = $AUTH_LANG;
  break;
  case $PHP_AUTH_LANG:
    $LANG_NAME = $PHP_AUTH_LANG;
  break;
  case $_SESSION['User']['PHP_AUTH_LANG']:
    $LANG_NAME = $_SESSION['User']['PHP_AUTH_LANG'];
  break;
  default:
    if (!$PHP_AUTH_LANG) $PHP_AUTH_LANG = NetCat_language_detect();
  	if ($PHP_AUTH_LANG) {
  		$LANG_NAME = $PHP_AUTH_LANG;
  	}
    else {
  		$LANG_NAME = $ADMIN_LANGUAGE;
  	}
}

// language file existance
if ( preg_match("/^\w+$/i", $LANG_NAME) && file_exists($nc_core->ADMIN_FOLDER."lang/".$LANG_NAME.".php") ) {
	require_once ($nc_core->ADMIN_FOLDER."lang/".$LANG_NAME.".php");
}
else {
	// choose someone else if no other variants
	if( $LANG_FOLDER = @opendir($nc_core->ADMIN_FOLDER."lang/") ) {
		while( ($LANG_FOLDER_FILE = readdir($LANG_FOLDER))!==false ) {
			if( substr($LANG_FOLDER_FILE, -3, 3)=="php" ) {
				require_once ($nc_core->ADMIN_FOLDER."lang/".$LANG_FOLDER_FILE);
        break;
			}
		}
	}
  else {
    die("Language folder is damaged!");
  }
}

// set template from current subdivision
if (!$template) $template = $nc_core->subdivision->get_current("Template_ID");

// set template as default
if ($template) {
  $nc_core->template->set_current_by_id($template);
}

// init log functional in stats module
if ( $nc_core->modules->get_vars('stats') ) stats_Log();

if ($nc_core->inside_admin) {
  if ( $nc_core->get_settings('EditDesignTemplateID') && !$nc_core->subdivision->get_current('UseEditDesignTemplate') ) {
    $template = $nc_core->get_settings('EditDesignTemplateID');
    // set template as current
    $nc_core->template->set_current_by_id($template);
  }
  require_once ($nc_core->ADMIN_FOLDER."admin.inc.php");
  ob_start("nc_postprocess_admin_page");
}

$template_settings = array();

$template_env = $nc_core->template->get_current();
$template_header = "";
$template_footer = "";

if (!$isNaked) {

  $template_header = $nc_core->template->get_current("Header");
  $template_footer = $nc_core->template->get_current("Footer");
  eval( $nc_core->template->get_current("Settings") );
  
  // add system CSS styles in admin mode
  if ($nc_core->get_variable("admin_mode") && !$nc_core->get_variable("inside_admin") && $template_header) {
    // addon css and js
    $template_admin_css = "<link type='text/css' rel='stylesheet' href='".$nc_core->get_variable("ADMIN_TEMPLATE")."css/admin_pages.css'/>\r\n";
    $template_admin_css .= "<script type='text/javascript' src='".$nc_core->get_variable("ADMIN_PATH")."js/package.js'></script>\r\n";
    // pattern and replacement for preg_replace()
    switch (true) {
      case preg_match("/\<\s*?\/head\s*?\>/im", $template_header):
        $preg_pattern = "/(\<\s*?\/head\s*?\>){1}/im";
        $preg_replacement = $template_admin_css."\n\$1";
      break;
      case preg_match("/\<\s*?html\s*?\>/im", $template_header):
        $preg_pattern = "/(\<\s*?html\s*?\>){1}/im";
        $preg_replacement = "\$1\n<head>".$template_admin_css."</head>";
      break;
      default:
        $preg_pattern = "/(\A)/im";
        $preg_replacement = $template_admin_css."\n\$1";
    }
    $template_header = preg_replace($preg_pattern, $preg_replacement, $template_header);
  }
  
  // $_GET['rand'] -        ,      
  //       QuickBar
  //   AUTH_USER_ID,    
  if ( $nc_core->get_variable("AUTHORIZATION_TYPE")!= 'http' ) {
    if ($nc_core->get_settings('QuickBar') && !$_GET['rand'] && ($AUTH_USER_ID || Authorize()) && is_object($perm) && $perm->isSupervisor() ) {
      $cookie_domain = ($nc_core->modules->get_vars('auth', 'COOKIES_WITH_SUBDOMAIN') ? str_replace("www.", "", $nc_core->get_variable("HTTP_HOST")) : NULL);
      if ($nc_core->input->fetch_cookie('QUICK_BAR_CLOSED')==0 || $nc_core->input->fetch_cookie('QUICK_BAR_CLOSED')==-1) {
        require_once ($nc_core->get_variable("INCLUDE_FOLDER")."quickbar.inc.php");
        $template_header = nc_quickbar_in_template_header($template_header);
        setcookie("QUICK_BAR_CLOSED", -1, time() + $nc_core->get_variable("ADMIN_AUTHTIME"), "/", $cookie_domain);
      }
      else {
        // refresh cookie expiration
        setcookie("QUICK_BAR_CLOSED", 1, time() + $nc_core->get_variable("ADMIN_AUTHTIME"), "/", $cookie_domain);
      }
    }
  }

  if ( $nc_core->template->get_current("CustomSettings") && $nc_core->subdivision->get_current('Template_ID')==$template) {
    require_once($nc_core->ADMIN_FOLDER . "array_to_form.inc.php");
    $nc_a2f = new nc_a2f( $nc_core->template->get_current("CustomSettings"), $nc_core->subdivision->get_current("TemplateSettings") );
    $template_settings = $nc_a2f->get_values_as_array();
  }
  if ( $nc_core->template->get_current("CustomSettings") && $nc_core->subdivision->get_current('Template_ID') != $template ) {
    require_once($nc_core->ADMIN_FOLDER. "array_to_form.inc.php");
    $nc_a2f = new nc_a2f( $nc_core->template->get_current("CustomSettings"),array() );
    $template_settings = $nc_a2f->get_values_as_array();
  }
  if ($nc_core->inside_admin) {
    // output interface settings (add 'em to the footer before </body>)
    $UI_CONFIG = new ui_config_objects($cc);
    $js_code = '".$UI_CONFIG->to_json()."';
    if ( preg_match("!(</body>)!i", $template_footer, $regs) ) {
      $template_footer = str_replace($regs[1], $js_code.$regs[1], $template_footer);
    }
    else {
      $template_footer .= $js_code;
    }
  }
}

if ( $nc_core->subdivision->get_current("Subdivision_ID")==$nc_core->catalogue->get_current("Title_Sub_ID") ) {
  $f_title = $nc_core->catalogue->get_current("Catalogue_Name");
}
else {
  $f_title = $nc_core->subdivision->get_current("Subdivision_Name");
}

if ( $nc_core->sub_class->get_current("Sub_Class_ID")!=$cc_array[0] && $nc_core->sub_class->get_current("Checked") ) $f_title = $nc_core->sub_class->get_current("Sub_Class_Name");

if (!$check_auth && NC_AUTH_IN_PROGRESS!==1) {

  eval("echo \"".$template_header."\";");

  if ( $AUTH_USER_ID || ( !$AUTH_USER_ID && !$nc_core->modules->get_vars('auth') ) ) {
    if ($nc_core->inside_admin) {
      nc_print_status(NETCAT_MODERATION_ERROR_NORIGHTS, 'error');
    }
    else {
      print NETCAT_MODERATION_ERROR_NORIGHTS;
    }
  }
  elseif ( !$AUTH_USER_ID && $nc_core->modules->get_vars('auth') ) {
    UserLoginForm();
  }

  eval("echo \"".$template_footer."\";");
  exit;
}

if (!$message && $action=="full") exit;
if ($AUTH_USER_ID) LoadUserEnv();

?>