<?php
/* $Id: s_e404.inc.php 3326 2009-06-05 10:54:31Z vadim $ */

function ObjectExists ($classID, $sysTbl, $cc, $keyword, $date = "") {
  global $db;
  
  switch ($sysTbl) {
    // system table
    case true:
      if ( $result = $db->get_var("SELECT `User_ID` FROM `User` WHERE `Keyword` = '".$db->escape($keyword)."'") ) {
        // check subclass by EnglishName for this table
        $keyword_result = $db->get_var("SELECT sc.`Sub_Class_ID`
          FROM `Sub_Class` AS sc
          LEFT JOIN `Class` AS cl ON sc.`Class_ID` = cl.`Class_ID`
          WHERE cl.`System_Table_ID` = 3 AND sc.`Sub_Class_ID` = '".intval($cc)."'");
      }
    break;
    // simple component
    default:
      if ($date && strtotime($date) > 0) {
        $Field_Name = $db->get_var("SELECT `Field_Name` FROM `Field`
          WHERE (`Format` = 'event' OR `Format` = 'event_date')
          AND `TypeOfData_ID` = 8 AND `Class_ID` = '".intval($classID)."'");
        if (!$Field_Name) return false;
        // set date condition
        $cond_date = " AND m.`".$Field_Name."` LIKE '".$db->escape($date)."%'";
      }
    
      $result = $db->get_var("SELECT m.`Message_ID`
        FROM `Message".intval($classID)."` AS m
        LEFT JOIN `Sub_Class` AS sc ON sc.`Sub_Class_ID` = m.`Sub_Class_ID`
        WHERE m.`Keyword` = '".$db->escape($keyword)."' AND sc.`Sub_Class_ID` = '".intval($cc)."'".$cond_date);
  }

  return $db->num_rows ? $result : false;
}

function ObjectExistsByID ($classID, $sysTbl, $cc_keyword, $id, $date = "") {
  global $db;
  
  switch ($sysTbl) {
    // system table
    case true:
      if ( $result = $db->get_var("SELECT `User_ID` FROM `User` WHERE `User_ID` = '".intval($id)."'") ) {
        // check subclass by EnglishName for this table
        $keyword_result = $db->get_var("SELECT sc.`Sub_Class_ID`
          FROM `Sub_Class` AS sc
          LEFT JOIN `Class` AS cl ON sc.`Class_ID` = cl.`Class_ID`
          WHERE cl.`System_Table_ID` = 3 AND sc.`EnglishName` = '".$cc_keyword."'");
      }
    break;
    // simple component
    default:
      if ($date && strtotime($date) > 0) {
        $Field_Name = $db->get_var("SELECT `Field_Name` FROM `Field`
          WHERE (`Format` = 'event' OR `Format` = 'event_date')
          AND `TypeOfData_ID` = 8 AND `Class_ID` = '".intval($classID)."'");
        if (!$Field_Name) return false;
        // set date condition
        $cond_date = " AND m.`".$Field_Name."` LIKE '".$db->escape($date)."%'";
      }
    
      $result = $db->get_var("SELECT m.`Message_ID`
        FROM `Message".intval($classID)."` AS m
        LEFT JOIN `Sub_Class` AS sc ON sc.`Sub_Class_ID` = m.`Sub_Class_ID`
        WHERE m.`Message_ID` = '".intval($id)."' AND sc.`EnglishName` = '".$cc_keyword."'".$cond_date);
  }
    
  return $db->num_rows ? $result : false;
}

/**
 *        hostname
 *
 * @param string $host
 * @return array
 */
function GetCatalogueByHostName($host) {
  global $db;

  $res = $db->get_row("(SELECT * FROM `Catalogue`
    WHERE Domain = '".$db->escape($host)."'
    OR (CONCAT('|', REPLACE(Mirrors, '\\n', '|')) LIKE '%|".$db->escape($host)."%') LIMIT 1)
    UNION (SELECT * FROM `Catalogue` ORDER BY `Checked` = 1, `Priority`, `Catalogue_ID` LIMIT 1)
    LIMIT 1", ARRAY_A);
  
  return $res;
}

//
function GetCatalogueID ($host) {
  global $db, $DOMAIN_NAME;

  $res = $db->get_var("SELECT `Catalogue_ID` FROM `Catalogue` WHERE IF(LOCATE('.',Domain),Domain,IF(Domain<>'',CONCAT(Domain,'.".$db->escape($DOMAIN_NAME)."'),'".$db->escape($DOMAIN_NAME)."'))='".$db->escape($host)."'");
  
  if ($db->num_rows) {
    $CatalogueID = $res;
    return ($CatalogueID);
  }
  else {
    $res = $db->get_results("SELECT `Catalogue_ID`, `Mirrors` FROM `Catalogue` ORDER BY `Catalogue_ID`", ARRAY_N);
    if ( empty($res) ) return 0;
    foreach ($res as $row) {
      list($CatalogueID, $Mirrors) = $row;
      $DomainArray = explode("\n",$Mirrors);
      for ($i=0; $i < count($DomainArray); $i++) {
        if ( trim($DomainArray[$i])==$host ) {
          return ($CatalogueID);
        }
      }
    }
  }
  return 0;
}

/**
  *       
  */
function GetSubdivisionByID($sub) {
  global $_cache, $db;
  $sub = (int)$sub;

  if (!$_cache["sub"][$sub]) {
    $_cache["sub"][$sub] = $db->get_row("SELECT * FROM `Subdivision` WHERE `Subdivision_ID` = '".intval($sub)."'", ARRAY_A);
  }

  return $_cache["sub"][$sub];
}


function GetSubdivisionID ($catalogue, $path) {
  global $db, $_cache, $nc_core;

  // validate Hidden_URL
  if ( !$nc_core->subdivision->validate_hidden_url($path) ) return false;
  
  $row = $db->get_row("SELECT * FROM `Subdivision` WHERE `Catalogue_ID` = '".intval($catalogue)."' AND `Hidden_URL` = '".$db->escape($path)."'", ARRAY_A);

  $_cache["sub"][$row["Subdivision_ID"]] = $row;
  
  return $row["Subdivision_ID"];
}


function AttemptToRedirect ($url) {
  // system superior object
  $nc_core = nc_Core::get_object();
  // GET data
  $get_data = $nc_core->input->fetch_get();
  
  if ( !empty($get_data) ) $url .= '?'.$nc_core->url->build_url($get_data);

  $res = $nc_core->db->get_row("SELECT REPLACE(NewURL,'*','\\\'),REPLACE(OldURL,'*','([[:alnum:]]+)') FROM `Redirect`
    WHERE '".$nc_core->db->escape($url)."' LIKE CONCAT('http://',REPLACE(REPLACE(OldURL,'_','\\\_'),'*','%'))
    OR '".$nc_core->db->escape($url)."' LIKE CONCAT('http://www.',REPLACE(REPLACE(OldURL,'_','\\\_'),'*','%')) ORDER BY LENGTH(OldURL) DESC LIMIT 1", ARRAY_N);
  
  if (!$nc_core->db->num_rows) return 0;

  list($new_url, $old_url) = $res;

  if ( strchr($new_url, "\\") ) {
    $result_url = ereg_replace($old_url, $new_url, $url);
  }
  else {
    $result_url = "http://".$new_url;
  }

  if ($nc_core->REDIRECT_STATUS=="on") {
    if ($nc_core->AUTHORIZATION_TYPE=='session') {
      if ( substr($result_url, -1)!='l' && substr($result_url, -1)!='/' ) {
        $result_url.= "&".session_name()."=".session_id();
      }
      else {
        $result_url.= "?".session_name()."=".session_id();
      }
    }

    if ($nc_core->PHP_TYPE=='cgi') header('Status: 301 Moved Permanently');

    header("Location: ".$result_url);
  }
  else {
    if ($nc_core->PHP_TYPE=='cgi') header('Status: 200 OK');
    echo "<meta http-equiv='refresh' content='0;url=http://".$result_url."'>";
  }
  exit;
}

?>