<?php
/* $Id: nc_message.class.php 3249 2009-05-13 13:03:50Z vadim $ */

class nc_Message extends nc_Essence {
  
  protected $db;
  
  /**
   * Constructor function
   */
  public function __construct () {
    // load parent constructor
    parent::__construct();
    
    // system superior object
    $nc_core = nc_Core::get_object();
    // system db object
    if ( is_object($nc_core->db) ) $this->db = $nc_core->db;
  }
  
  public function get_current () {
    // dummy
    return false;    
  }
  
  public function set_current_by_id () {
    // dummy
    return false;    
  }
  
  public function get_by_id ($class_id, $id, $item = "", $reset = false) {
    // call as static
    static $storage = array();
 
    // validate parameters
    $class_id = intval($class_id);
    $id = intval($id);
    
    // check inited object
    if ( empty($storage[$class_id][$id]) || $reset ) {
      $storage[$class_id][$id] = $this->db->get_row("SELECT * FROM `".$this->essence.$class_id."`
      WHERE `".$this->essence."_ID` = '".$id."'", ARRAY_A);
    }
   
    // if item requested return item value
    if ( $item && is_array($storage[$class_id][$id]) ) {
      return array_key_exists($item, $storage[$class_id][$id]) ? $storage[$class_id][$id][$item] : "";
    }
    
    return $storage[$class_id][$id];
  }
  
  public function delete_by_id ($class_id, $id) {
  
    // validate parameters
    $class_id = intval($class_id);
    $id = intval($id);
    
    $this->db->query("DELETE FROM `".$this->essence.$class_id."` WHERE `".$this->essence."_ID` = '".$id."'");
    
    return $this->db->rows_affected;
  }
  
}

?>