<?php
/* $Id: nc_template.class.php 3253 2009-05-13 19:12:51Z vadim $ */

class nc_Template extends nc_Essence {
  
  protected $db;
  
  /**
   * Constructor function
   */  
  public function __construct () {
    // load parent constructor
    parent::__construct();
    
    // system superior object
    $nc_core = nc_Core::get_object();
    // system db object
    if ( is_object($nc_core->db) ) $this->db = $nc_core->db;
    
  }
  
  protected function inherit ($template_env) {
    global $perm, $AUTH_USER_ID, $templatePreview;

    // system superior object
    $nc_core = nc_Core::get_object();
    
    //     
    $magic_gpc = get_magic_quotes_gpc();
    if ( $template_env["Template_ID"] == $templatePreview && !empty($_SESSION["PreviewTemplate"][$templatePreview]) ) {
      foreach($_SESSION["PreviewTemplate"][$templatePreview] as $key => $value) {
        $template_env[$key] = $magic_gpc ? stripslashes($value) : $value;
      }
    }

    $parent_template = $template_env["Parent_Template_ID"];
    while ($parent_template) {
      
      $parent_template_env = $this->get_by_id($parent_template);
    
      //      ,      .
      if ( $parent_template_env["Template_ID"]==$templatePreview && !empty($_SESSION["PreviewTemplate"][$templatePreview]) ) {
        foreach($_SESSION["PreviewTemplate"][$templatePreview] as $key => $value) {
          $parent_template_env[$key] = $magic_gpc ? stripslashes($value) : $value;
        }
      }

      $parent_template = $template_env["Parent_Template_ID"];

      if (!$template_env["Header"]) {
        $template_env["Header"] = $parent_template_env["Header"];
      }
      else {
        if ($parent_template_env["Header"]) { $template_env["Header"] = str_replace ("%Header", $parent_template_env["Header"], $template_env["Header"]); }
      }
      if (!$template_env["Footer"]) {
        $template_env["Footer"] = $parent_template_env["Footer"];
      }
      else {
        if ($parent_template_env["Footer"]) { $template_env["Footer"] = str_replace ("%Footer", $parent_template_env["Footer"], $template_env["Footer"]); }
      }
      $template_env["Settings"] = $parent_template_env["Settings"].$template_env["Settings"];
      
      $template_env = $this->inherit_system_fields($this->essence, $parent_template_env, $template_env);
      $parent_template = $parent_template_env["Parent_Template_ID"];
    }

    // load system table fields
    $table_fields = $nc_core->get_system_table_fields($this->essence);
    // count
    $counted_fileds = count( $table_fields );
    
    for ($i=0; $i < $counted_fileds; $i++) {
      $template_env["Header"] = str_replace("%".$table_fields[$i]['name'], $template_env[$table_fields[$i]['name']], $template_env["Header"]);
      $template_env["Footer"] = str_replace("%".$table_fields[$i]['name'], $template_env[$table_fields[$i]['name']], $template_env["Footer"]);
    }
    
    return $template_env;
  }
  
}

?>